#
# sendmail.rb
#

require 'net/smtp'
require 'parsearg'

def usage( stat = 1 )
  print <<MSG

sendmail.rb
  send mail to SMTP server from stdin/file

usage:
  ruby sendmail.rb [-s <server-addr>] [-f <filename>]
                   [-u <username>] [-d <domain>] <to> <to> ...

MSG
  exit stat
end
$USAGE = 'usage'
parseArgs( 1, nil, 'h',
           's:', 'f:', 'u:', 'd:', 'help' )

if $OPT_h or $OPT_help then
  usage 0
end

serv       = $OPT_s || 'localhost'
helo_dom   = $OPT_d || ENV['HOSTNAME']
user       = $OPT_u ? $OPT_u : ENV['USERNAME']
from_addr  = user + '@' + helo_dom
to_addrs   = ARGV
input      = $OPT_f ? File.open( $OPT_f ) : $stdin


Net::SMTP.start( serv, 25, helo_dom ) do |smtp|
  smtp.sendmail( input, from_addr, to_addrs )
end

input.close if input != $stdin

puts sprintf( 'sent %d mail%s', ARGV.size, ARGV.size > 1 ? 's' : '' )
